; 

    .486                      ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\macros\macros.asm

    ttLabelProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .data?
      lpttLblProc dd ?

    .code

; 

ttLabel proc lpText:DWORD,hParent:DWORD,instance:DWORD,
                     a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,
                     tColor:DWORD,talign:DWORD

    LOCAL httLabel  :DWORD

    fn CreateWindowEx,WS_EX_TRANSPARENT,"STATIC",lpText, \
                      WS_CHILD or WS_VISIBLE, \
                      a,b,wd,ht,hParent,0, \
                      instance,NULL
    mov httLabel, eax

    mov lpttLblProc, rv(SetWindowLong,httLabel,GWL_WNDPROC,ttLabelProc)
    invoke SetWindowLong,httLabel,GWL_USERDATA,tColor
    invoke SetWindowLong,httLabel,GWL_ID,talign

    mov eax, httLabel

    ret

ttLabel endp

; 

ttLabelProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hDC   :DWORD 
    LOCAL ptxt  :DWORD
    LOCAL hFont :DWORD
    LOCAL hOld  :DWORD
    LOCAL DT_STYLE  :DWORD
    LOCAL tlen  :DWORD
    LOCAL rct   :RECT
    LOCAL ps    :PAINTSTRUCT

    .if uMsg == WM_PAINT
      switch rv(GetWindowLong,hWin,GWL_ID)
        case -1
          mov DT_STYLE, DT_LEFT or DT_NOCLIP or DT_WORDBREAK
        case 0
          mov DT_STYLE, DT_CENTER or DT_NOCLIP or DT_WORDBREAK
        case 1
          mov DT_STYLE, DT_RIGHT or DT_NOCLIP or DT_WORDBREAK
      endsw

      mov tlen, rv(GetWindowTextLength,hWin)
      add tlen, 1
      mov ptxt, alloc(tlen)
      invoke GetWindowText,hWin,ptxt,tlen
      mov hDC, rv(BeginPaint,hWin,ADDR ps)
      mov hFont, rv(SendMessage,hWin,WM_GETFONT,0,0)
      mov hOld, rv(SelectObject,hDC,hFont)
      invoke GetClientRect,hWin,ADDR rct
      fn SetBkMode,hDC,TRANSPARENT

      add rct.left, 1
      add rct.top, 1
      add rct.right, 1
      add rct.bottom, 1
      invoke SetTextColor,hDC,00000000h
      fn DrawText,hDC,ptxt,-1,ADDR rct,DT_STYLE

      sub rct.left, 1
      sub rct.top, 1
      sub rct.right, 1
      sub rct.bottom, 1
      invoke SetTextColor,hDC,rv(GetWindowLong,hWin,GWL_USERDATA)
      fn DrawText,hDC,ptxt,-1,ADDR rct,DT_STYLE

      invoke SelectObject,hDC,hOld
      free ptxt
      invoke EndPaint,hWin,ADDR ps
      xor eax, eax
      ret

    .endif

    invoke CallWindowProc,lpttLblProc,hWin,uMsg,wParam,lParam

    ret

ttLabelProc endp

; 

end
